// rf69 demo tx rx.pde
// -*- mode: C++ -*-
// Example sketch showing how to create a simple messageing client
// with the RH_RF69 class. RH_RF69 class does not provide for addressing or
// reliability, so you should only use RH_RF69  if you do not need the higher
// level messaging abilities.
// It is designed to work with the other example rf69_server.
// Demonstrates the use of AES encryption, setting the frequency and modem 
// configuration

//    digitalWrite(0)         //--> D0
//    digitalWrite(1)         //--> D1
//    digitalWrite(2)         //--> D2
//    digitalWrite(3,LOW);    //--> D3
//    digitalWrite(4,LOW);    //--> D4
//    digitalWrite(5,LOW);    //--> D5
//    digitalWrite(6,LOW);    //--> D6
//    digitalWrite(7,LOW);    //--> D7
//    digitalWrite(8,HIGH);   //--> B0 
//    digitalWrite(9,HIGH);   //--> B1
//    digitalWrite(10,HIGH);  //--> B2 SSO
//    digitalWrite(11,HIGH);  //--> B3 MOSI
//    digitalWrite(12,HIGH);  //--> B4 MISO
//    digitalWrite(13,HIGH);  //--> B5 SCK
//    digitalWrite(14,LOW);   //--> C0
//    digitalWrite(15,LOW);   //--> C1
//    digitalWrite(16,LOW);   //--> C2 
//    digitalWrite(17,LOW);   //--> C3
//    digitalWrite(18,LOW);   //--> XX
//    digitalWrite(19,LOW);   //--> XX
//    digitalWrite(20,LOW);   //--> XX
//    digitalWrite(21,LOW);   //--> XX
//    digitalWrite(22,LOW);   //--> XX
//    digitalWrite(23,LOW);   //--> E0
//    digitalWrite(24,LOW);   //--> E1
//    pinMode(A2, INPUT_PULLUP); //-->25 (ALSO C2)
#include <SPI.h>
#include <RH_RF69.h>
#include <TimeLib.h>

/************ Radio Setup ***************/
// Change to 434.0 or other frequency, must match RX's freq!
#define RF69_FREQ 915
#define RFM69_INT   2  // 
#define RFM69_CS   10  //
#define RFM69_RST  24  // "A"
int hours = 18;
int minutes = 56;
int seconds = 0;
int days = 1;
int months = 2;
int years = 2020;
unsigned len;
// Singleton instance of the radio driver
RH_RF69 rf69(RFM69_CS, RFM69_INT);

int16_t packetnum = 0;  // packet counter, we increment per xmission, 16 bit int

void setup() 
{
  setTime(hours, minutes, seconds, days, months, years);
  Serial.begin(115200);
  while (!Serial) { delay(1); } // wait until serial console is open, remove if not tethered to computer
  pinMode(A2, INPUT_PULLUP); // CHECK IF INTERNAL PULLUP
  pinMode(23, OUTPUT);  
  pinMode(3, OUTPUT);  
  pinMode(4, OUTPUT); 
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);    
  pinMode(RFM69_RST, OUTPUT);
  digitalWrite(RFM69_RST, LOW);

  Serial.println("Feather RFM69 TX Test!");
  Serial.println();

// manual reset
  digitalWrite(RFM69_RST, HIGH);
  delay(10);
  digitalWrite(RFM69_RST, LOW);
  delay(10);
  
  if (!rf69.init()) {
    Serial.println("RFM69 radio init failed");
    digitalWrite(23, HIGH);
    digitalWrite(6, HIGH);
    digitalWrite(5, HIGH);
    digitalWrite(4, HIGH);
    digitalWrite(3, HIGH);
    delay(30);
    digitalWrite(3, LOW);
    delay(30);
    while (1);
  }
  Serial.println("RFM69 radio init OK!");  
    digitalWrite(23, HIGH);
    digitalWrite(6, HIGH);
    digitalWrite(5, HIGH);
    digitalWrite(3, HIGH);
    digitalWrite(4, HIGH);
    delay(50);
    digitalWrite(4, LOW);
    delay(50);
  // Defaults after init are 434.0MHz, modulation GFSK_Rb250Fd250, +13dbM (for low power module)
  // No encryption
  if (!rf69.setFrequency(RF69_FREQ)) {
    Serial.println("setFrequency failed");
  }

  // If you are using a high power RF69 eg RFM69HW, you *must* set a Tx power with the
  // ishighpowermodule flag set like this:
  rf69.setTxPower(20, true);  // range from 14-20 for power, 2nd arg must be true for 69HCW

  // The encryption key has to be the same as the one in the server
  uint8_t key[] = { 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,
                    0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08};
  rf69.setEncryptionKey(key);
  
  Serial.print("RFM69 radio @");  Serial.print((int)RF69_FREQ);  Serial.println(" MHz");
}

void loop() {
  delay(1000);  // Wait 1 second between transmits, could also 'sleep' here!
  int sensorValue = analogRead(A2); // int
  Serial.println(sensorValue);
  String b;
  char c[4];
  b = (String)sensorValue;
  b.toCharArray(c,4);    
  rf69.send((uint8_t *)c, strlen(c)); // original code byte, strlen (returns long int)
  Serial.print("Sending: "); Serial.print(c); Serial.println(strlen(c)); 
    // rf69.send((uint8_t *)radiopacket, strlen(radiopacket)); // original code byte, strlen (returns long int)
    // param[in] data Array of data to be sent
    // param[in] len Number of bytes of data to send (> 0)
    // return true if the message length was valid and it was correctly queued for transmit
  rf69.waitPacketSent();
    digitalWrite(6, HIGH);
    digitalWrite(5, HIGH);
    digitalWrite(3, HIGH);
    digitalWrite(4, HIGH);    
    digitalWrite(23, LOW);
    delay(30);
    digitalWrite(23, HIGH);
    delay(30);
  // Now wait for a reply
  uint8_t buf[RH_RF69_MAX_MESSAGE_LEN];
  uint8_t len = sizeof(buf);

  if (rf69.waitAvailableTimeout(500))  { 
    // Should be a reply message for us now   
    if (rf69.recv(buf, &len)) {
     Serial.print("Got a reply: ");
     Serial.println((char*)buf);
     digitalWrite(23, HIGH);
     digitalWrite(6, HIGH);
     digitalWrite(3, HIGH);
     digitalWrite(4, HIGH);
     digitalWrite(5, LOW);
     delay(50);
     digitalWrite(5, HIGH);
     delay(50);
     digitalWrite(5, LOW);
     delay(50);
     digitalWrite(5, HIGH);
     delay(50);
     digitalWrite(5, LOW);
     delay(50);
    } else {
      Serial.println("Receive failed");
    }
  } else {
    Serial.println("No reply, is another RFM69 listening?");
     digitalWrite(23, HIGH);
     digitalWrite(5, HIGH);
     digitalWrite(3, HIGH);
     digitalWrite(4, HIGH);
     digitalWrite(6, LOW);
     delay(30);
     digitalWrite(6, HIGH);
     delay(30);
     digitalWrite(6, LOW);
     delay(30);
     digitalWrite(6, HIGH);
  }
}

void Blink(byte PIN, byte DELAY_MS, byte loops) {
  for (byte i=0; i<loops; i++)  {
    digitalWrite(PIN,HIGH);
    delay(DELAY_MS);
    digitalWrite(PIN,LOW);
    delay(DELAY_MS);
  }
}
void digitalClockDisplay() {
  // digital clock display of the time
  Serial.println(" ");
  Serial.print("The time is now: ");
  Serial.print(hour());
  Serial.print(":");
  Serial.print(minute());
  Serial.print(":");
  Serial.print(second());
  Serial.println(" ");
}

